@ECHO OFF
:: ddlistW.cmd - small batch by jaclaz - Release 0.1 ALPHA
:: 28th December 2008 - Version changed according to wimb suggestion
:: using the features of John Newbigin's dd for windows
:: http://www.chrysocome.net/dd
:: tested version 0.5:
:: http://www.chrysocome.net/downloads/dd-0.5.zip
::  
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION

:: changing the work directory according to cdob to allow Run as admin - 26-02-2020
:: http://reboot.pro/topic/22238-question-about-zero-and-random-device-driver-found-on-olofs-homepage/?p=213984
:: echo %~dpn0 %*
:: echo %cd%
:: pause
cd /d "%~dp0"
:: echo %cd%
:: pause

SET FLAG=0
Set /A Counter=10

For /F  "skip=4 tokens=*" %%A IN ('dd --list 2^>^&1') DO (
SET Thisline=%%A
SET Partline=!Thisline:~0,7!

IF "!Partline!"=="\\.\Vol" (
SET /A COunter+=1
SET Volume!Counter!=!Thisline:~10,38!
)

IF "!Partline!"=="NT Bloc" SET FLAG=1

IF !FLAG!==0 (
IF "!Partline!"=="link to" SET link!Counter!=!Thisline:~19,40!
IF NOT "!Partline!"=="Mounted" SET media!Counter!=!Thisline!
) ELSE (
IF "!Partline!"=="link to" SET tolink!Counter!=!Thisline:~19,40!
)


IF "!Partline!"=="Mounted" SET Letter!Counter!=!Thisline:~15,2!

IF "media!Counter!"=="CD-ROM" CALL :isCDROM !Counter!

IF "!Partline!"=="\\?\Dev" (
SET /A Counter+=1
SET drive!Counter!=!Thisline:~11,40!
Set isCD=!Thisline:~11,5!
IF "!isCD!"=="CdRom" CALL :isCDROM !Counter!
)

)


SET /A MaxCounter=%Counter%-1



FOR /F "tokens=1,2 delims==. " %%A IN ('SET media') DO (
SET %%A=%%B
If "!%%A!"=="fixed" SET %%A=FIX
If "!%%A!"=="removeable" SET %%A=REM
If "!%%A!"=="CD-ROM" SET %%A=CDR
)



FOR /F  "tokens=1,2,3,4,6 delims=e=k\n" %%A IN ('set drive') DO (
SET Thisline=%%C
SET Partline=!Thisline:~0,5!
SET g%%Ae%%B=%%D,%%E
IF "!Partline!"=="CdRom" SET gdrive%%B=x,x
FOR /L %%F IN (10,1,%MaXcounter%) DO (
IF "!tolink%%B!"=="!link%%F!" SET Line%%B=!letter%%F! !gdrive%%B! !media%%F! \Volume!volume%%F! \!tolink%%B!
)
)


ECHO Drives by drive letter:
FOR /F "tokens=2 delims==" %%A IN (' SET Line  ^| SORT /+8') DO ECHO %%A
PAUSE
ECHO.
ECHO Drives by connection:
FOR /F "tokens=2 delims==" %%A IN (' SET Line  ^| SORT /+11') DO ECHO %%A
PAUSE
GOTO :EOF

:isCDROM
SET tolink%1=!drive%1!
GOTO :EOF